/*
 *  It is assumed that the person who is executing the Makefile
 *  has an interactive terminal that works. Therefore, we steal
 *  the terminal settings from that process.
 */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <termios.h>
int main (void);
int main()
{
    int i;
    struct termios st;
    unsigned char *cp;
    if((i = open("/dev/tty", O_RDONLY)) < 0)
    {
        fprintf(stderr, "Your system is mucked up!\n");
        exit(EXIT_FAILURE);
    }
    if(tcgetattr(i, &st) < 0)
    {
        fprintf(stderr, "Your system is mucked up!\n");
        exit(EXIT_FAILURE);
    }
    (void)close(i);
    printf("#define TTYCCS {\\\n");
    for(i=0; i< 32; i++)
    {
        if(!(i%8) && (i)) printf(" \\\n");
        if(i < 31)
            printf("0x%02x, ", st.c_cc[i]);
        else
            printf("0x%02x } \n", st.c_cc[i]);
    }
    printf("\n#define TERMIOS {\\\n");
    cp = (unsigned char *) &st;
    for(i=0; i< sizeof(st); i++)
    {
        if(!(i%8) && (i)) printf(" \\\n");
        if(i < sizeof(st)-1)
            printf("0x%02x, ", *cp++);
        else
            printf("0x%02x } \n", *cp);
    }
    return 0;
}

